apps/pro/ui/config/routes.rb
            resources :vulns, only: [:index, :show]
            resources :web_sites, only: [:index, :show] do
              resources :web_forms, only: [:index, :show]
              resources :web_pages, only: [:index, :show]
              resources :web_vulns, only: [:index, :show]
            end
          end
        end
      end
    end
  end

  # Wizards
  namespace :wizards do
    namespace :quick_pentest do
      resources :form
    end
    namespace :quick_web_app_scan do
      resources :form
    end
    namespace :vuln_validation do
      resources :form do
        collection do
          get  :nexpose_sites
          get  :import_run
          post :continue_exploitation
        end
      end
    end
    namespace :payload_generator do
      resources :form do
        collection do
          get :poll
          get :download
          get :upsell
        end
      end
    end
  end

  # Notifications
  namespace :notifications do
    resources :messages do
      collection do
        post 'mark_read' => 'messages#mark_read', :as => 'mark_read'
        get 'poll' => 'messages#poll', :as => 'poll'
      end
    end
  end

  # Setup & Licenses
  scope "/setup" do
    get ""           => "licenses#setup", :as => "setup"
    get "request"    => "licenses#request_key", :as => "request_key"
    get "activation" => "licenses#activation", :as => "activation"
  end

  scope "/licenses" do
    get ""        => "licenses#index",    :as => "licenses"
    post "register" => "licenses#register", :as => "register"
    post "activate" => "licenses#activate", :as => "activate"
    match "offline_activation" => "licenses#offline_activation", :as => "offline_activation", :via => [:get, :post]
  end

  # Updates
  scope "/updates" do
    get ""             => "updates#updates", :as => "updates"
    post "check"         => "updates#check"
    post "apply"         => "updates#apply"
    post "restart"       => "updates#restart"
    post "status"        => "updates#status"
    get  "offline_apply" => "updates#offline_apply"
    post "offline_apply_post" => "updates#offline_apply_post", :as => 'updates_offline_apply_post'
  end

  # NeXpose Consoles
  resources :nexpose_consoles do
    collection do
      delete "/destroy" => "nexpose_consoles#destroy", :as => "destroy"
    end
  end

  # API Keys
  resources :api_keys do
    collection do
      delete "/destroy" => "api_keys#destroy", :as => "destroy"
    end

    member do
      post "/reveal" => "api_keys#reveal"
    end
  end



  # Macros
  resources :macros
  scope "/macro" do
    delete ":id/delete_action/:action_id" => "macros#delete_action", :as => "macro_delete_action"
    delete ":id/delete_action" => "macros#delete_action", :as => "macro_delete_actions"
    post ":id/add_action" => "macros#add_action", :as => "macro_add_action"
    match "module_options" => "macros#module_options", :as => "module_options", via: [:get, :post]
  end
  delete "macros" => "macros#destroy", :as => "delete_macros"


  # Listeners
  resources :listeners
  scope "/listener" do
    post ":id/stop" => "listeners#stop", :as => "listener_stop"
    post ":id/start" => "listeners#start", :as => "listener_start"
    get "module_options" => "listeners#module_options", :as => "macro_module_options"
  end
  delete "listeners" => "listeners#destroy", :as => "delete_listeners"


  # Global Settings
  scope "/settings" do
    get "" => "settings#index", :as => "settings"
    patch "update_profile" => "settings#update_profile", :as => "update_profile"
    put "update_profile" => "settings#update_profile"
  end


  # Mdm::User settings
  resources :users

  get "login" => "user_sessions#new", :as => "login"
  get "logout" => "user_sessions#destroy", :as => "logout"

  resources :user_sessions

  # Workspaces
  get "/workspaces/search" => "workspaces#search"
  delete "/workspaces/destroy" => "workspaces#destroy"

  # Wizard related reporting routes
  get '/wizard_report_tab' => 'reports#form_for_tabbed_modal', :as => 'wizard_report_tab_form'

  resources :workspaces do
    get "sessions" => "sessions#index"
    get "events" => "events#index"
    get "web" => "web#index"

    resources :imports, only: [:new]


    # Reports and Exports
    # Standard reports
    resources :reports do
      collection do
        post  "validate_report" => "reports#validate_report", :as=> "validate_report"
        # Wrapper to allow all the other report partials
        # to be reloaded once type is selected:
        get :form_for_type
        delete :destroy_multiple
      end
      member do
        get :clone
        post :generate_format
        post :format_generation_status
      end

      # Generated report files
      resources :report_artifacts, only: [:destroy, :index] do
        member do
          get :download
          get :view
        end

        collection do
          post :email
        end
      end
    end

    # Outside of reports to avoid dealing with report IDs unnecessarily:
    get 'report_artifact_download/(:id)',       to: 'report_artifacts#download'
    get 'report_artifact_view/:id',             to: 'report_artifacts#view'

    # Custom reports
    resources :custom_reports, { :controller => :reports }

    # Resources for custom reports: logos, templates
    resources :report_custom_resources

    # Example simple template
    get 'report_template_simple_download',      to: 'reports#download_simple_sample'

    resources :exports do
      member do
        get 'download' => 'exports#download'
      end
      collection do
        delete :destroy_multiple
      end
    end

    resources :task_chains, except: [:show] do
      collection do
        post "validate_schedule" => 'task_chains#validate_schedule', :as => 'validate_schedule'
        post "validate" => 'task_chains#validate', :as=>'validate'
        delete :destroy_multiple
        post   :stop_multiple
        post   :suspend_multiple
        post   :resume_multiple
        post   :start_multiple
      end

      member do
        get :clone
      end
    end

    namespace :fuzzing do
      resources :fuzzing do
        resources :request_groups
      end
    end

    namespace :nexpose do
      namespace :result do
        # fixme: CHANGE TO POST TO PREVENT CSRF.
        get 'push_validations' => 'exceptions#push_validations'
        resources :exceptions, only: [:create, :show, :update]
        resources :validations, only: [:create, :show, :update]
      end
      namespace :data do
        resources :sites, only: [:index] do
          collection {
            get :search_operators
            get :filter_values
          }
        end
        resources :import_runs, only:[:create,:show]
      end
    end


    # NEW STYLE!
    # Social Engineering Campaigns
    namespace :social_engineering do
      resources :human_targets

      resources :web_templates, except: [:delete] do
        collection do
          post :clone_proxy
          delete "" => "web_templates#destroy", :as => "delete"
        end
      end

      resources :email_templates, except: [:delete]  do
        collection do
          delete "" => "email_templates#destroy", :as => "delete"
        end
      end

      resources :target_lists, except: [:delete]  do
        get "export" => "target_lists#export"
        post "remove_targets" => "target_lists#remove_targets"
        collection do
          delete "" => "target_lists#destroy", :as => "delete"
        end
      end

      resources :files, except: [:delete]  do
        collection do
          delete "" => "files#destroy", :as => "delete"
        end
      end

      # ------ Campaigns, components, and tracking data -----
      resources :campaigns do

        resource :web_server_config, {
            :only => [:edit, :update],
            :controller => :web_server_config
        }
        resource :email_server_config, {
            :only => [:edit, :update],
            :controller => :email_server_config
        } do
          collection do
            match :check_smtp, via: [:put, :patch]
          end
        end

        resources :visits

        resources :emails do
          get :preview
          get :preview_pane
          collection do
            post :custom_content_preview
          end
        end

        resources :web_pages do
          get :preview
          get :preview_pane
          collection do
            post :clone_proxy
            post :custom_content_preview
          end
        end

        resources :portable_files do
          member do
            get :download
          end
        end

        member do
          post :execute
          post :reset
          get  :to_task
          get  :sent_emails
          get  :opened_emails
          get  :opened_sessions
          get  :submitted_forms
          get  :links_clicked
          get  :check_for_configuration_errors
        end

        collection do
          delete "" => "campaigns#destroy", :as => "delete"
          get :logged_in
        end
        resources :phishing_results, :only => [:index, :show]
      end
    end
    # ------ RunStat -----
    resources :run_stats, :only => [:show]


    # ------ WebScan -----
    resources :web_scans, :only => [:show]


    delete "/tags/destroy" => "tags#destroy"
    resources :tags do
      collection do
        delete :destroy, :as => "destroy"
        get :search
      end
    end

    resources :loots, :only => [:index, :destroy] do
      collection do
        delete :destroy_multiple
      end
    end

    #Creds Management
    resources :creds, :only => [:index] do
    end


    # Notes, Services
    [:notes, :services].each do |res|
      resources res, :only => [:index] do
        collection do
          get :combined
          delete :destroy_multiple
        end
      end
    end

    # Note Creation
    resources :notes, only: [:create]


    # Module Detail
    resources :module_details, only:[:show]


    # Vulnerabilities

apps/pro/ui/app/controllers/settings_controller.rb
class SettingsController < ApplicationController

  before_filter :require_admin

  def index
    @macros    = Mdm::Macro.all
    @api_keys  = Mdm::ApiKey.all
    @listeners = Mdm::Listener.all
    @consoles  = Mdm::NexposeConsole.all
    @profile   = current_profile
  end

  def update_profile
    pid = params[:profile_id]
    params[:smtp_ssl] = true if params[:smtp_ssl] == "true"

    @profile = Mdm::Profile.find(pid)

    if @profile.blank?
      flash[:error] = "Invalid Mdm::Profile ID"
      redirect_to :action => 'index'
    end

    @profile.settings_list.each do |s|
      key = s[:name].intern
      val = params[key]

      next if val.nil?

      if s[:type] == :boolean
        val = (val.to_s =~ /(true|1|yes)/) ? true : false
      end
      @profile.settings[s[:name]] = val
    end

    update_smtp_settings if smtp_settings_present?
    update_proxy_settings
    @profile.save!

    Mdm::Profile.record_timestamps = false
    @profile.update_attributes :updated_at => Time.now.utc
    Mdm::Profile.record_timestamps = true

    @profile.load_smtp_configuration

    flash[:notice] = "Settings successfully updated."

    redirect_to :action => 'index', :anchor => params[:anchor]
  end

  private

  # Ensure that SMTP information is complete if provided.
  # @return [Boolean]
  def smtp_settings_valid?
    status, error_msg = check_smtp_settings

    if status == :error
      flash[:error] = "SMTP Settings Error: #{error_msg}"
      false
    else
      true
    end
  end

  # Assume the user wants to use an SMTP server if they have anything in the address field
  # @return [Boolean]
  def smtp_settings_present?
    params[:smtp_address].present?
  end


  def update_proxy_settings
    Mdm::Profile::HTTP_PROXY_SETTINGS.each do |setting|
      @profile.settings[setting.to_s] = (@profile.settings["use_http_proxy"] ? params[setting] : nil)
    end
  end

  def update_smtp_settings
    SmtpSettings.new(params).apply_to(@profile.settings)
  end

  # Perform a check of the provided SMTP information to ensure that the server
  # is up and responds to the settings.
  def check_smtp_settings
    use_ssl = params[:smtp_ssl]
    server = params[:smtp_address]
    port = params[:smtp_port].to_i
    username = params[:smtp_username]
    password = params[:smtp_password]
    domain = params[:smtp_domain]
    auth = params[:smtp_authentication]
    if password == SmtpSettings::PASSWORD_UNCHANGED
      password = @profile.settings['smtp_password']
    end
    settings_validator = SmtpSettingsValidator.new(
        :server => server,
        :port => port,
        :ssl => use_ssl,
        :domain => domain,
        :username => username,
        :password => password,
        :auth => auth)
    valid = settings_validator.valid?
    error_msg = settings_validator.errors.join(', ')
    status = valid ? :ok : :error
    [status, error_msg]
  end

end

apps/pro/ui/app/helpers/settings_helper.rb
module SettingsHelper
end

apps/pro/ui/app/views/settings/_profile.html.erb
<% include_javascript 'settings/_profile' %>

<div class="profile_settings">

  <%= form_tag update_profile_path, :method => :patch do %>

  <%= hidden_field_tag 'profile_id', @profile.id %>
  <%= hidden_field_tag 'anchor', 'global_settings' %>

    <table id="profile_settings_list" class="list">
      <thead>
        <th>Value</th>
        <th>Category</th>
        <th>Setting</th>
        <th>Description</th>
      </thead>
      <tbody>

      <% @profile.settings_list.each do |s|
        val = @profile.settings.has_key?(s[:name]) ? @profile.settings[s[:name]] : s[:default]
      %>
      <tr class="<%=h row_cycle %>">
        <td width="20">
          <%  case s[:type]
            when :boolean
                  # Ensure possibility of toggling setting state. See http://apidock.com/rails/ActionView/Helpers/FormHelper/check_box %>
              <%= hidden_field_tag h(s[:name]), 0 %>
              <%= check_box_tag h(s[:name]), true, val %>
            <%
            when :text
            %>
              <%= text_field_tag h(s[:name]), true, h(val) %>
            <%
            end
          %>
        </td>
        <td width="20">
          <b><%= s[:category] %></b>
        </td>
        <td width="30">
          <b><%=h s[:name] %></b>
        </td>
        <td>
          <%=h s[:desc] %>
        </td>
      </tr>
      <% end %>

      </tbody>
    </table>

    <div class="proxy_settings">
      <div id="proxy_fields" style="<%= display_none_if !@profile.settings["use_http_proxy"] %>" class="inline_fields">
        <h3>HTTP Proxy Settings</h3>
        <p>
          <%= label_tag :http_proxy_host, "Proxy IP" %>
          <%= text_field_tag :http_proxy_host, @profile.settings["http_proxy_host"] %>
        </p>

        <p>
          <%= label_tag :http_proxy_port, "Port" %>
          <%= text_field_tag :http_proxy_port, @profile.settings["http_proxy_port"], :size => 5 %>
        </p>

        <p>
          <%= label_tag :http_proxy_user, "Username" %>
          <%= text_field_tag :http_proxy_user, @profile.settings["http_proxy_user"], :autocomplete => "off" %>
        </p>

        <p>
          <%= label_tag :http_proxy_pass, "Password" %>
          <%= password_field_tag :http_proxy_pass, @profile.settings["http_proxy_pass"], :autocomplete => "off" %>
        </p>
      </div>
    </div>
    <br />
    <div class="buttons">
      <span class="btn"><%= submit_tag 'Update Settings', :method => :patch, :class => "save" %></span>
    </div>

  <% end %>

  <% javascript_tag do %>
    (function() {
      jQuery(function($) {
        $("#use_proxy").toggleVisibility($("#proxy_fields"));
      });
    }).call(this);
  <% end %>

</div>

apps/pro/ui/app/views/settings/_smtp.html.erb
<% smtp = @profile.smtp_settings %>
<div class="smtp_settings">
  <h2></h2>

  <%= form_tag update_profile_path, :method => :put do %>
    <%= hidden_field_tag 'profile_id', @profile.id %>
    <%= hidden_field_tag 'anchor', 'smtp_settings' %>
    <div id="smtp_fields" class="inline_fields">      
      <p>
        <%= label_tag :smtp_address, "Address" %>
        <%= text_field_tag :smtp_address, smtp.address %>
      </p>
      <p>
        <%= label_tag :smtp_port, "Port" %>
        <%= text_field_tag :smtp_port, smtp.port, :size => 5 %>
      </p>
      <p>
        <%= label_tag :smtp_ssl, "Use SSL?" %>
        <%= check_box_tag :smtp_ssl, true, smtp.ssl%>
      <p>
        <%= label_tag :smtp_domain, "Domain" %>
        <%= text_field_tag :smtp_domain, smtp.domain %>
      </p>
      <p>
        <%= label_tag :smtp_username, "Username" %>
        <%= text_field_tag :smtp_username, smtp.username, :autocomplete => "off" %>
      </p>
      <p>
        <%= label_tag :smtp_password, "Password" %>
                <% safe_password = nil

                   unless smtp.password.blank?
                     safe_password = SmtpSettings::PASSWORD_UNCHANGED
                   end %>
        <%= password_field_tag :smtp_password, safe_password, :autocomplete => "off" %>
      </p>
      <p>
        <%= label_tag :smtp_authentication, "Authentication" %>
        <%= select_tag :smtp_authentication, 
            options_for_select(['plain', 'login', 'cram_md5'], smtp.authentication) %>
      </p>
    </div>
    <br />
    <div class="buttons">
      <span class="btn"><%= submit_tag 'Update Settings', :method => :put, :class => "save" %></span>
    </div>
  <% end %>
</div>

apps/pro/ui/app/views/settings/index.html.erb
<% title "Global Settings" %>
<% breadcrumb link_to("Global Settings", settings_path) %>
<% include_stylesheet 'settings/index' -%>
<% include_javascript "api_keys/_index" %>
<% include_javascript "macros" %>
<% include_javascript "nexpose_consoles" %>
<% include_javascript "listeners/_index" %>
<% include_javascript "settings/_index" %>

<ul class='tabs'>
  <li class='tab'><a class='active' href='javascript:void(0)'>Global Settings</a></li>

  <li class='tab'><a href='javascript:void(0)'>SMTP Settings</a></li>

  <% if License.get.supports_api? %>
    <li class='tab'><a href='javascript:void(0)'>API Keys</a></li>
  <% end %>

  <% if License.get.supports_macros? %>
    <li class='tab'><a href='javascript:void(0)'>Post-Exploitation Macros</a></li>
  <% end %>

  <% if License.get.supports_listeners? %>
    <li class='tab'><a href='javascript:void(0)'>Persistent Listeners</a></li>
  <% end %>

  <li class='tab'><a href='javascript:void(0)'>Nexpose Consoles</a></li>

  <% if current_user.admin %>
    <li class='tab'><a href='javascript:void(0)'>Stop All Tasks</a></li>
  <% end %>
</ul>

<style type='text/css'>
div.tabs>div {
  margin-top: 18px;
}
</style>

<div class='tabs'>
  <div id="profile_container">
    <%= render "profile", :profile => @profile %>
  </div>

  <div id="smtp_container">
    <%= render "smtp", :profile => @profile %>
  </div>

  <% if License.get.supports_api? %>
    <div id="api_keys_container">
      <%= render "api_keys/api_keys", :apikeys => @api_keys %>
    </div>
  <% end %>

  <% if License.get.supports_macros? %>
    <div id="macros_container">
      <%= render "macros/macros", :macros => @macros %>
    </div>
  <% end %>

  <% if License.get.supports_listeners? %>
    <div id="listeners_container">
      <%= render "listeners/listeners", :listeners => @listeners %>
    </div>
  <% end %>

  <div id="consoles_container">
    <%= render "nexpose_consoles/nexpose_consoles", :consoles => @consoles %>
  </div>

  <% if current_user.admin %>
    <div id="stop-all-tasks">
      <h2 style="color:red">Stop all tasks in all projects</h2>
      <p><strong>This will stop every single running task in the application.  Be VERY sure you want to do this!</strong></p>
        <span class="btn">
        <%= link_to_remote 'Stop all tasks', {:url => stop_all_tasks_path, :method => :post, :confirm => 'Immediately stop all tasks in the application? There is no undo!'}, :class => 'cancel', :title => "Stop all tasks" %>
      </div>
    </div>
  <% end %>
</div>